#include "pg.h"
#include "syscall.h"

#define SND1_MAXSLOT 16

typedef struct {
	unsigned long channels;
	unsigned long samplerate;
	unsigned long samplecount;
	unsigned long datalength;
	char *wavdata;
	unsigned long rateratio;		// samplerate / 44100 * 0x10000
	unsigned long playptr;
	unsigned long playptr_frac;
	int playloop;
} wavout_wavinfo_t;

wavout_wavinfo_t wavinfo_bg;
wavout_wavinfo_t *wavout_snd0_wavinfo=0;
int wavout_snd0_ready=0;
int wavout_snd0_playend=0;
unsigned long wavout_snd0_playptr=0;
int wavout_snd1_playing[SND1_MAXSLOT];
unsigned long cur_play;
unsigned long cur_nloop;

static void wavout_snd0_callback(short *_buf, unsigned long _reqn)
{
	static int power[128];

	unsigned long i;
	unsigned long ptr,frac,rr,max;
	int channels;
	char *src;
	short *buf=_buf;
	unsigned long reqn=_reqn;

	wavout_wavinfo_t *wi=wavout_snd0_wavinfo;

	if (wi==0) {
		wavout_snd0_ready=1;
		_memset(buf,0,reqn*4);
		return;
	}

	wavout_snd0_ready=0;

	ptr=wi->playptr;
	frac=wi->playptr_frac;
	rr=wi->rateratio;
	max=wi->samplecount;
	channels=wi->channels;
	src=wi->wavdata;

	cur_nloop=0;
	if (channels==1) {
		for (; reqn>0; --reqn) {
			frac+=rr;
			ptr+=(frac>>16);
			cur_play = ptr*4;
			frac&=0xffff;
			if (ptr>=max) {
				if (wi->playloop) {
					ptr=0;
					cur_nloop++;
				} else {
					for (; reqn>0; --reqn) {
						*(buf++)=0;
						*(buf++)=0;
					}
					goto playend;
				}
			}
			buf[0]=buf[1]=*(short *)(src+ptr*2);
			buf+=2;
		}
	} else {
		for (; reqn>0; --reqn) {
			frac+=rr;
			ptr+=(frac>>16);
			cur_play = ptr*4;
			frac&=0xffff;
			if (ptr>=max) {
				if (wi->playloop) {
					ptr=0;
					cur_nloop++;
				} else {
					for (; reqn>0; --reqn) {
						*(buf++)=0;
						*(buf++)=0;
					}
					goto playend;
				}
			}
			buf[0]=*(short *)(src+ptr*4);
			buf[1]=*(short *)(src+ptr*4+2);
			buf+=2;
		}
	}

	//powercalc(_buf);	//PwaveoȂsv

	wavout_snd0_playptr=ptr;
	wi->playptr=ptr;
	wi->playptr_frac=frac;
	return;

playend:
	wavout_snd0_playend=1;
	return;
}

//return 0 if success
int wavoutInit()
{
	int i;

	wavout_snd0_wavinfo=0;

	for (i=0; i<SND1_MAXSLOT; i++) {
		wavout_snd1_playing[i]=0;
	}

	pgaSetChannelCallback(0,wavout_snd0_callback);
	//pgaSetChannelCallback(1,wavout_snd1_callback);
	return 0;
}

void wavoutStopPlay0()
{
	if (wavout_snd0_wavinfo!=0) {
		while (wavout_snd0_ready) pgWaitV();
		wavout_snd0_wavinfo=0;
		while (!wavout_snd0_ready) pgWaitV();
	}
}

void wavoutStartPlay0(wavout_wavinfo_t *wi)
{
	wavoutStopPlay0();
	while (!wavout_snd0_ready) pgWaitV();
	wavout_snd0_playptr=0;
	wavout_snd0_playend=0;
	wavout_snd0_wavinfo=wi;
	while (wavout_snd0_ready) pgWaitV();
}

int wavoutWaitEnd0()
{
	if (wavout_snd0_wavinfo==0) return -1;
	if (wavout_snd0_wavinfo->playloop) return -1;
	while (!wavout_snd0_playend) pgWaitV();
	return 0;
}
